#include "Engine/Engine.h"

namespace Flux
{
    bool FluxEngine::GIsRunning = false;
    FluxEngine* FluxEngine::GInstance = nullptr;

    FluxEngine::FluxEngine() : _Logger(*new Logger())
    {
        if (GIsRunning)
        {
            GetLogger()->LogTrace("Engine already running!");
            bErrorState = true;
            return;
        }

        if (GInstance != nullptr)
        {
            FluxEngine* Engine = GetInstance();

            if (Engine)
            {
                Engine->GetLogger()->LogTrace("Engine already running!");
            }
            return;
        }

        GInstance = this;
    }

    FluxEngine::~FluxEngine()
    {
        GetLogger()->LogTrace("Engine shutting down!");
    }

    void FluxEngine::Start()
    {
        if (bErrorState)
        {
            GetLogger()->LogTrace("Engine failed to start!");
            return;
        }

        GetLogger()->LogTrace("Engine started!");
        GIsRunning = true;
        EngineLoop();
    }

    void Flux::FluxEngine::EngineLoop()
    {
        while (IsRunning())
        {
            GetLogger()->LogTrace("Loop running!");
            // Main engine loop
            // Update, render, etc.
        }
    }
}
