﻿#include "Log.h"

#include "spdlog/spdlog.h"
#include "spdlog/sinks/stdout_color_sinks.h"

namespace Flux
{
    struct LoggerImpl 
    {
        LoggerImpl() = default;
        ~LoggerImpl() = default;

        std::shared_ptr<spdlog::logger> _logger;
    };

    Logger::~Logger() = default;

    spdlog::logger *Logger::GetLogger() const
    {
        return _impl._logger.get();
    }

    Logger::Logger() : _impl(* new LoggerImpl())
    {
        // Initialize the logger
        if (GetLogger()) {
            return;
        }

        // Create a new logger instance
        spdlog::set_pattern("%^[%T] %n: %v%$");
        
        _impl._logger = spdlog::stdout_color_mt("FLUX");
        _impl._logger->set_level(spdlog::level::trace);

        LogTrace("Logger initialized!");
    }

    void Logger::LogTrace(const std::string &message)
    {
        spdlog::logger* logger = GetLogger();

        if (!logger)
        {
            return;
        }

        logger->trace(message);
    }
}
