#pragma once

#include "Core.h"
#include "Log.h"
#include <memory>

namespace Flux
{
    class FLUX_API FluxEngine
    {
    public:
        FluxEngine();
        ~FluxEngine();

        void Start();

        static FluxEngine* GetInstance()
        {
            return GInstance;
        }

        static bool IsRunning()
        {
            return GIsRunning;
        }

        static Logger* GetLogger()
        {
            if (GIsRunning || GInstance != nullptr)
            {
                FluxEngine* Engine = GetInstance();
                if (Engine)
                {
                    return &Engine->_Logger;
                }
            }

            return nullptr;
        }

        void RequestExit()
        {
            GIsRunning = false;
        }

        void EngineLoop();

    private:
        Flux::Logger& _Logger;

        static bool GIsRunning;
        static FluxEngine* GInstance;

        bool bErrorState = false;
    };
}